﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BlazorStripeTest.Models;
using BlazorStripeTest.Stripe;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Stripe;
using Stripe.Checkout;

namespace BlazorStripeTest.Controllers
{
    [Authorize]
    [Route("api/[controller]")]
    [ApiController]
    public class StripeController : Controller
    {

        [AllowAnonymous]
        [HttpGet]
        [Route("test")]
        public string Test(string value)
        {
            return value;
        }

        [AllowAnonymous]
        [HttpGet]
        [Route("createcharge")]
        public IActionResult CreateCharge(string sessionid, Int64 amout, string currencycode, Int64 orderId)
        {
            StripeConfiguration.ApiKey = StripeConfig.SecretKey;
            // Retrieve the session
            var sessionService = new SessionService();
            var session = sessionService.Get(sessionid);
            // Create then payment intent (for Stripe)
            var paymentIntentService = new PaymentIntentService();
            try
            {
                // Capture the payment corresponding to then PaymentIntentId
                paymentIntentService.Capture(session.PaymentIntentId);
                return Redirect($"~/checkout/Y/" + amout.ToString() + "/" + currencycode);
            }
            catch (StripeException ex)
            {
                TempData["Error"] = ex.StripeError.Message;
                return Redirect($"~/checkout/N/" + amout.ToString() + "/" + currencycode + "/" + ex.StripeError.Message);
            }
        }

    }
}